<template>
  <div class="system">
    <Loading :loading="this.$apollo.queries.system.loading" />

    <b-row v-if="!this.$apollo.queries.system.loading">
      <b-col md="8">
        <p class="caption">System under test</p>
        <h1>{{ system.name }}</h1>
        <SystemControls :system="system" style="margin: 1rem 0;" />

        <div>
          <h2>Builds</h2>
          <p>
            {{ system.builds.length || "No" }} {{ system.name }} builds are
            available for testing {{ system.builds.length ? "" : "yet..." }}
          </p>
          <b-table
            v-show="system.builds && system.builds.length"
            :items="system.builds"
            :fields="[
              { key: 'tag', sortable: true },
              { key: 'date', sortable: true },
              { key: 'channel', sortable: true },
              { key: 'status', sortable: true }
            ]"
            sort-by="date"
            :sort-desc="true"
            selectable
            select-mode="single"
            class="mt-3"
            outlined
            striped
            hover
            @row-selected="buildSelected"
          >
            <template v-slot:cell(tag)="data">
              <router-link :to="`/build/${data.item.id}`">
                {{ data.value }}
              </router-link>
            </template>
            <template v-slot:cell(date)="data">
              {{ new Date(Number(data.item.date)).toLocaleString() }}
            </template>
            <template v-slot:cell(status)="data">
              <Status :status="data.item.status" />
            </template>
          </b-table>
        </div>

        <div>
          <h2>Tests</h2>
          <p>
            There are {{ system.tests.length || "no" }} tests defined for
            {{ system.name }} {{ !system.tests.length ? "yet..." : "" }}
          </p>
          <b-table
            v-show="system.tests && system.tests.length"
            :items="system.tests"
            :fields="[
              { key: 'name', sortable: true },
              { key: 'description', sortable: true },
              { key: 'group', sortable: true },
              { key: 'weight', sortable: true }
            ]"
            sort-by="group"
            :sort-desc="true"
            selectable
            select-mode="single"
            class="mt-3"
            outlined
            striped
            hover
            @row-selected="testSelected"
          >
            <template v-slot:cell(name)="data">
              <router-link :to="`/test/${data.item.id}`">
                {{ data.value }}
              </router-link>
            </template>
          </b-table>
        </div>
      </b-col>

      <SystemSidebar md="4" :system="system" />
    </b-row>
  </div>
</template>

<script>
import Status from "@/components/Status.vue";
import Loading from "@/components/Loading.vue";
import SystemControls from "@/components/SystemControls.vue";
import SystemSidebar from "@/components/SystemSidebar.vue";
import gql from "graphql-tag";

export default {
  name: "System",
  data() {
    return {
      system: {
        id: this.$route.params.id,
        tests: [],
        builds: []
      }
    };
  },
  components: {
    Status,
    Loading,
    SystemControls,
    SystemSidebar
  },
  apollo: {
    system: {
      query: gql`
        query system($systemId: ID!) {
          system(id: $systemId) {
            id
            name
            description
            image
            logLink
            buildDiscovery {
              engine
              args
            }
            builds {
              id
              tag
              date
              channel
              status {
                pass
                wonky
                fail
                inconclusive
              }
            }
            tests {
              id
              name
              description
              group
              weight
            }
            combinationFilter
            properties {
              id
              name
              description
              values
            }
          }
        }
      `,
      variables() {
        return {
          systemId: this.$route.params.id
        };
      },
      error() {
        this.$router.push({ path: `/dashboard/` });
      }
    }
  },
  methods: {
    testSelected(items) {
      this.$router.push({ path: `/test/${items[0].id}` });
    },
    buildSelected(items) {
      this.$router.push({ path: `/build/${items[0].id}` });
    }
  }
};
</script>
